﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace RadMultiSelectDropDownListImpl
{  
    public class MyDynamicCollection : IList<CustomListDataItem>
    {
        RadMultiSelectDropDownList owner;      

        public MyDynamicCollection(RadMultiSelectDropDownList owner)
        {
            this.owner = owner;
        }

        public void Add(CustomListDataItem item)
        {
            item.Checked = true;
        }

        public void Clear()
        {
            for (int i = 0; i < owner.Items.Count; i++)
            {
                ((CustomListDataItem)owner.Items[i]).Checked = false;
            }
        }

        public bool Contains(CustomListDataItem item)
        {
            for (int i = 0; i < owner.Items.Count; i++)
            {
                if (((CustomListDataItem)owner.Items[i]).Checked)
                {
                    if (owner.Items[i] == item)
                    {
                        return true;
                    }
                }
            }

            return false;
        }

        public void CopyTo(CustomListDataItem[] array, int arrayIndex)
        {
            throw new NotImplementedException();
        }

        public int Count
        {
            get
            {
                int counter = 0;

                for (int i = 0; i < owner.Items.Count; i++)
                {
                    if (((CustomListDataItem)owner.Items[i]).Checked)
                    {
                        counter++;
                    }
                }

                Console.WriteLine(owner.Items[0].Selected + " " + owner.Items[1].Selected + " " + owner.Items[2].Selected + " " + owner.Items[3].Selected + " " + owner.Items[4].Selected);
                Console.WriteLine("SelectedItems Count " + counter);
                return counter;
            }
        }

        public bool IsReadOnly
        {
            get { return false; }
        }

        public bool Remove(CustomListDataItem item)
        {
            item.Checked = false;

            return true;
        }

        public IEnumerator<CustomListDataItem> GetEnumerator()
        {
            return new MyCollectionEnumerator(owner, this);
        }

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return new MyCollectionEnumerator(owner, this);
        }

        public int IndexOf(CustomListDataItem item)
        {
            int counter = 0;

            for (int i = 0; i < owner.Items.Count; i++)
            {
                if (((CustomListDataItem)owner.Items[i]).Checked)
                {
                    if (owner.Items[i] == item)
                    {
                        return counter;
                    }

                    counter++;
                }
            }

            return -1;
        }

        public void Insert(int index, CustomListDataItem item)
        {
            // throw new NotImplementedException();
        }

        public void RemoveAt(int index)
        {
            int counter = 0;
            CustomListDataItem itemToBeRemoved = null;

            for (int i = 0; i < owner.Items.Count; i++)
            {
                if (((CustomListDataItem)owner.Items[i]).Checked)
                {
                    if (counter == index)
                    {
                        itemToBeRemoved = (CustomListDataItem)owner.Items[i];
                        ((CustomListDataItem)owner.Items[i]).Checked = false;
                    }

                    counter++;
                }
            }
        }

        public CustomListDataItem this[int index]
        {
            get
            {
                int counter = 0;

                for (int i = 0; i < owner.Items.Count; i++)
                {
                    if (((CustomListDataItem)owner.Items[i]).Checked)
                    {
                        if (counter == index)
                        {
                            return (CustomListDataItem)owner.Items[i];
                        }

                        counter++;
                    }
                }

                throw new IndexOutOfRangeException();
            }
            set
            {
                int counter = 0;

                for (int i = 0; i < owner.Items.Count; i++)
                {
                    if (((CustomListDataItem)owner.Items[i]).Checked)
                    {
                        if (counter == index)
                        {
                            owner.Items[i] = value;
                        }

                        counter++;
                    }
                }

                throw new IndexOutOfRangeException();
            }
        }

        public override string ToString()
        {
            string selectedItems = String.Empty;
            for (int i = 0; i < this.Count; i++)
            {
                selectedItems += this[i].Text + " ";
            }

            return selectedItems;
        }
    }  
}
